
/* AMX Mod script. 
* 
* (c) Copyright 2002, Namralkeeg 
* This file is provided as is (no warranties). 
* 
* This plugin will perform kick, ban, or rename on someone based on a list of 
* names and the specified flag. It will also pick from a set of provided names 
* to randomly rename someone. 
* 
* The default is for someone to get banned for 120 minutes on a ban violation. 
* Default name for renaming someone is NewName if none are provided. 
* 
* Flags: 
* a = kick 
* b = ban 
* c = rename 
* d = substring match 
* e = exact match 
* 
* 
* Example nameban.cfg: 

// Random names for people to get changed to. 
amx_nameban_names "I bow down to keeg" 
amx_nameban_names "You Will Lose" 
amx_nameban_names "ilovetofart" 
amx_nameban_names "Ilovetopee" 
amx_nameban_names "Noclue" 
amx_nameban_names "<== Potty Mouth" 
amx_nameban_names "LlamaBoy" 
amx_nameban_names "2Dumb2ChangeMyName" 

// Names to ban 

// Rename with substring search. 
amx_nameban "whome"      "cd" 

// Rename with exact match. 
amx_nameban "slacker"   "ce" 

// Kick on substring match. 
amx_nameban "kickme"   "ad" 

// Ban on substring match. 
amx_nameban "banme"      "bd" 

*/ 

#include <amxmod> 

#define NAMEBAN_KICK       (1<<0)   /* flag "a" */ 
#define NAMEBAN_BAN         (1<<1)  /* flag "b" */ 
#define NAMEBAN_RENAME       (1<<2)   /* flag "c" */ 
#define NAMEBAN_EXACT       (1<<3)   /* flag "d" */ 
#define NAMEBAN_SUBSTRING   (1<<4)   /* flag "e" */ 


#define MAX_BAN_NAMES       50 
#define MAX_CHANGE_NAMES   10 
#define MAX_NAME_LENGTH    33 
new bantime[] =   {"120"} 
new defaultName[] = {"NewName"} 
new cfgfile[] = "addons/amx/nameban.cfg"

new bannedNameList[MAX_BAN_NAMES][MAX_NAME_LENGTH] 
new flagList[MAX_BAN_NAMES] 
new numBannedNames = 0 

new changeNameList[MAX_CHANGE_NAMES][MAX_NAME_LENGTH] 
new numChangeNames = 0 

public nameban() 
{ 
   if (read_argc() != 3){ 
      server_print("Usage: amx_nameban ^"name^" ^"flags^"") 
      return PLUGIN_HANDLED 
   } 

   new currName[MAX_NAME_LENGTH] 
   new flagStr[3] 

   read_argv(1,currName,MAX_NAME_LENGTH) 
   read_argv(2,flagStr,2) 

   for(new i = 0; i < numBannedNames; i++) 
   { 
      if(equali(currName,bannedNameList[i])) 
      { 
             server_print("[AMX] Banned Name %s already registered!",currName) 
             return PLUGIN_HANDLED 
      } 
   } 

   copy(bannedNameList[numBannedNames],MAX_NAME_LENGTH,currName) 

   if(containi(flagStr,"c")>=0) 
      flagList[numBannedNames] |= NAMEBAN_RENAME 
   else if(containi(flagStr,"a")>=0) 
      flagList[numBannedNames] |= NAMEBAN_KICK 
   else if(containi(flagStr,"b")>=0) 
      flagList[numBannedNames] |= NAMEBAN_BAN 
   else 
      flagList[numBannedNames] |= NAMEBAN_RENAME 

   if(containi(flagStr,"d")>=0) 
      flagList[numBannedNames] |= NAMEBAN_SUBSTRING 
   else if(containi(flagStr,"e")>=0) 
      flagList[numBannedNames] |= NAMEBAN_EXACT 
   else 
      flagList[numBannedNames] |= NAMEBAN_SUBSTRING 


      server_print("[AMX] Banned Name added: %s",bannedNameList[numBannedNames]) 
      numBannedNames++ 

   return PLUGIN_HANDLED 
} 

public nameban_names() 
{ 
   if (read_argc() < 2) { 
      server_print("Usage: amx_nameban_names ^"name^"") 
      return PLUGIN_HANDLED 
   } 

   new currName[MAX_NAME_LENGTH] 

   read_argv(1,currName,MAX_NAME_LENGTH) 

   for(new i = 0; i < numChangeNames; i++) 
   { 
      if(equal(currName,changeNameList[i])) 
      { 
             server_print("[AMX] Replacement Name %s already registered!",currName) 
             return PLUGIN_HANDLED 
      } 
   } 

   copy(changeNameList[numChangeNames],MAX_NAME_LENGTH,currName) 

      server_print("[AMX] Replacement Name added: %s",changeNameList[numChangeNames]) 
      numChangeNames++ 

   return PLUGIN_HANDLED 
} 

public client_connect(id) 
{ 
   if(get_user_flags(id) & ADMIN_IMMUNITY) 
      return PLUGIN_CONTINUE 

   if(numBannedNames) 
   { 
      new playername[MAX_NAME_LENGTH] 
      get_user_name(id,playername,MAX_NAME_LENGTH) 
      return check_name(id,playername) 
   } 

   return PLUGIN_CONTINUE 
} 

public client_infochanged(id) 
{ 
   if(get_user_flags(id)&ADMIN_IMMUNITY) 
      return PLUGIN_CONTINUE 

   if(numBannedNames) 
   { 
      new playername[MAX_NAME_LENGTH], oldname[MAX_NAME_LENGTH] 
      get_user_info(id, "name", playername,MAX_NAME_LENGTH) 
      get_user_name(id,oldname,MAX_NAME_LENGTH) 

      if(!equal(oldname,playername)) 
         return check_name(id,playername) 
   } 

   return PLUGIN_CONTINUE 
} 

check_name(id,playername[]) 
{ 
   new status = 0 
   for(new i = 0; i < numBannedNames; i++) 
   { 
      status = 0 
      if(flagList[i]&NAMEBAN_SUBSTRING) { 
         status = containi(playername,bannedNameList[i]) 
         if(status == 0) 
            status = 1 
         else if(status == -1) 
            status = 0 
      } 
      else if(flagList[i]&NAMEBAN_EXACT) 
         status = equali(playername,bannedNameList[i]) 

      if(status) 
      { 

         if(flagList[i] & NAMEBAN_KICK) 
         { 
            new idx[2] 
            idx[0] = id 
            set_task(10.0,"delay_kick",0,idx,2) 
            return PLUGIN_CONTINUE 
         } 
         if(flagList[i] & NAMEBAN_BAN) 
         { 
            new idx[2] 
            idx[0] = id 
            set_task(10.0,"delay_ban",0,idx,2) 
            return PLUGIN_CONTINUE 
         } 
         else if(flagList[i] & NAMEBAN_RENAME) 
         { 
            new randomName 
            if(numChangeNames >= 1) 
               randomName = random_num(1,numChangeNames)-1 
            else if(numChangeNames == 1) 
               randomName = 0 
            else 
               randomName = -1 

            if(randomName>=0) 
               set_user_info(id,"name",changeNameList[randomName]) 
            else 
               set_user_info(id,"name",defaultName) 

            client_cmd(id,"echo ^"[AMX] That Nick Is Banned On This Server.^"") 
            client_cmd(id,"echo ^"[AMX] Changing Nick to: %s.^"",changeNameList[randomName]) 

            return PLUGIN_CONTINUE 
         } 
      } 
   } 

   return PLUGIN_CONTINUE 
} 

public delay_kick(idx[]) 
{ 
   new userid = get_user_userid(idx[0]) 
   client_cmd(idx[0],"echo ^"[AMX] You have been kicked for a name VIOLATION!^"") 
   server_cmd("kick #%d",userid) 

   return PLUGIN_CONTINUE 
} 

public delay_ban(idx[]) 
{ 
   new authid[16] 
   get_user_authid(idx[0],authid,16) 
   client_cmd(idx[0],"echo ^"[AMX] You have been banned for a name VIOLATION!.^"") 
   server_cmd("banid %s %s kick;writeid",bantime,authid) 
} 

public nameban_reload()
{
   numBannedNames = 0 
   numChangeNames = 0
   server_cmd("exec %s", cfgfile)
}

public plugin_init() 
{ 
   register_plugin("AMX Nameban","0.2","Namralkeeg") 
   register_srvcmd("amx_nameban", "nameban") 
   register_srvcmd("amx_nameban_names","nameban_names") 
   register_srvcmd("amx_nameban_reload","nameban_reload") 
   register_cvar("KEEG_Nameban", "0.2",FCVAR_SERVER) 
   server_cmd("exec %s",cfgfile) 

   return PLUGIN_CONTINUE 
} 

